% Do accurate SVD a la DGESVD
% Inputs: 
%   X full column rank
%   D diagonal 
%   Y full column rank, 
%     where we want the SVD of G = X*D*Y^T
% Outputs: 
%   U, S, V where G = U*S*V^T
%   relerrbnd = relative error bound from DGESVD for SVD
%   Jnum = number of one-sided Jacobi sweeps
function [U,S,V,relerrbnd,Jnum]=accsvd1(X,D,Y)
[Q,R,p]=qr(X*D,0);
P=eye(size(D,1)); P=P(:,p);
Rp = diag(1./diag(R))*R;
% relerrbnd = eps/rcond(Rp)/rcond(X)/rcond(Y);
relerrbnd=1;
W = R*P'*Y';
% Do Jacobi from left instead of right; faster convergence!
% figure(3), hold off, clf, spy_mat1(W,0)
% figure(4), hold off, clf, spy(W)
[V,S,Ubar,Jnum]=dgesv2(W');
U = Q*Ubar;
